#include "individu.h"

#include <stdlib.h>
#include <math.h>
#include "outils.h"


/* Variables globales contenant les probabilités de mutation et croisement      */
/* Usage de variables globales normalement à éviter mais fait ici pour l'usage  */
/* de 'extern'                                                                  */
extern double p_mutation;
extern double p_croisement;


individu creation_individu(int doitall){
  individu man;
  man = (individu) malloc (sizeof(struct individu));
  if (doitall){
    man->gene[0] = uniforme(0, 2);
    man->gene[1] = uniforme(0, 2);
    man->rosenbrock = rosenbrock(man);
    man->fitness = exp(-10 * man->rosenbrock);  
  }
  return man;
}

individu reproduction(individu man, individu woman){
  int g, pere;
  individu child = creation_individu(0);
  double weight[TAILLE_GENOME];
  double biais = man->fitness/(man->fitness + woman->fitness);

  if(uniforme(0,1) < p_croisement) /* On fait un croisement pour de vrai */
    for(g=0; g<TAILLE_GENOME; g++)
      weight[g] = uniforme(0,1);
  else{                           /* on recopie simplement le père ou la mère */
      pere = uniforme(0,1)<=biais ? 1.0:0.0;
      for(g=0; g<TAILLE_GENOME; g++)
	weight[g] = pere;
  }
  
  for(g=0; g<TAILLE_GENOME; g++){
    child->gene[g] = weight[g] * man->gene[g] + (1-weight[g]) * woman->gene[g];
    if(uniforme(0, 1) < p_mutation) /* Si besoin, on fait une petite mutation */
      child->gene[g] = uniforme(0, 2);
  }
  child->rosenbrock = rosenbrock(child);
  child->fitness = exp(-10 * child->rosenbrock);

  return child;
}

double rosenbrock(individu man){
  double x=man->gene[0], y=man->gene[1];
  return (1-x)*(1-x) + 100 * (y-x*x)*(y-x*x);
}

void destruction_individu(individu man){
  if(man)
    free(man);
}

