#ifndef __INDIVIDU__
#define __INDIVIDU__

#define TAILLE_GENOME 2

typedef struct individu *individu;
struct individu{
  double gene[TAILLE_GENOME];
  double rosenbrock;
  double fitness;
};

/* Crée un individu avec (éventuellement) un génome calculé au hasard */
individu creation_individu(int);

/* Procède à la reproduction de 2 individus: croisement + mutation */
individu reproduction(individu, individu);

/* Calcule la valeur de rosenbrock d'un individu */
double rosenbrock(individu);

/* Détruit un individu et libère la mémoire */
void destruction_individu(individu);

#endif
