#include "io.h"

#include <stdio.h>

#include "population.h"
#include "individu.h"

void affiche_individu(individu man){
  printf("x=%3.4e  |  y=%3.4e  |  rosenbrock=%3.4e  | fitness=%3.4e  |", man->gene[0], man->gene[1], man->rosenbrock, man->fitness); 
}

void affiche_population(population pop){
  int g;
  printf("Population de %d individus, fitness=%f\n", pop->taille, pop->fitness);
  for(g=0; g<pop->taille; g++){
    printf("%04d | ", g);
    affiche_individu(pop->genome[g]);
    printf("\n");
  }
}

void affiche_synthese(population pop){
  int g, best_guy=0;
  double m, M, rosenbrock;
  m = M = pop->genome[0]->fitness;
  rosenbrock = pop->genome[0]->rosenbrock;
  for(g=0; g<pop->taille; g++){
    if(pop->genome[g]->fitness < m)
      m = pop->genome[g]->fitness;
    if(pop->genome[g]->fitness > M){
      best_guy = g;
      M = pop->genome[g]->fitness;
      rosenbrock = pop->genome[g]->rosenbrock;
    }
  }
  printf("%3.4e  | %3.4e  | %3.4e | %3.4e |", m, M, rosenbrock, pop->fitness/pop->taille);
  affiche_individu(pop->genome[best_guy]);
  printf("\n");
}
