#include "population.h"
#include "outils.h"

#include <stdlib.h>


population genese(int n){
  population pop;
  int man;

  pop=creation_population(n);

  for(man=0; man<n; man++){
    pop->genome[man] = creation_individu(1);
    pop->fitness += pop->genome[man]->fitness;
  }

  return pop;
}

population creation_population(int n){
  population pop;
  
  if(n%2) n = n+1;

  pop = (population) malloc(sizeof(struct population));
  pop->taille = n;
  pop->fitness = 0.0;
  pop->genome = (individu *) malloc(n * sizeof(individu));

  return pop;
}

loterie selection_parents(population pop){
  int p, man;
  double needle, mass;
  loterie tirage = (loterie) malloc(pop->taille * sizeof(int));

  for(p=0; p<pop->taille; p++){
    needle = uniforme(0,1);
    mass = 0;
    man = 0;
    while(mass < needle * pop->fitness && man < pop->taille){
      mass += pop->genome[man]->fitness;
      man ++;
    }
   tirage[p] = man-1;
  }
  return tirage;
}

population nouvelle_generation(population pop){

  population newpop = creation_population(pop->taille);
  loterie tirage = selection_parents(pop);
  int man, pere, mere;

  for(man=0; man<pop->taille; man+=2){
    pere = tirage[man];
    mere = tirage[man+1];
    newpop->genome[man] = reproduction(pop->genome[pere], pop->genome[mere]);
    newpop->genome[man+1] = reproduction(pop->genome[pere], pop->genome[mere]);
    newpop->fitness += newpop->genome[man]->fitness + newpop->genome[man+1]->fitness ;
    /*printf("\nPere : "); affiche_individu(pop->genome[pere]);
    printf("\nMere : "); affiche_individu(pop->genome[mere]);
    printf("\nFille : "); affiche_individu(newpop->genome[man]);
    printf("\nFils : "); affiche_individu(newpop->genome[man+1]);*/

  }

  free(tirage);
  return newpop;
}

void destruction_population(population pop){
  int man;

  for(man=0; man<pop->taille; man++){
    destruction_individu(pop->genome[man]);
  }
  free(pop->genome);
  free(pop);
}
